#import "LightCont.h"

#include <string.h>
#include <sys/xattr.h>//Spotlightコメント設定用

@implementation LightCont

/**初期化
*初期化を行う。
*
*[memo]
*大事なのは「query=nil」
*/
- (void)awakeFromNib {
    NSLog(@"初期化");
    NSString *appPath = [ [ NSBundle mainBundle ] bundlePath ];
    NSLog(appPath);
    NSLog(NSUserName());
    query=nil;
}


/**ファイルの選択
*情報を表示するファイルを選択する
*
*[memo]
*「~/Picture」が最初に選択されている、選択できるのは画像だけ、
*このプログラムではSpotlight検索範囲が「~/Picture」内の画像だけなのでそうしている。
*/
- (IBAction)FileChoice:(NSButton *)sender {
    //NSLog(@"Clicked file select button \n");
    
    //OpenPanelを作る
    NSOpenPanel *opPanel = [NSOpenPanel openPanel];
    
    //OpenPanelの結果のボタン番号
    int	 opRet;
    
    //OpenPanelでファイル選択
    opRet = [ opPanel 
                //どこのディレクトリを出すか（今回は「~/Pictures」）
                runModalForDirectory : [NSString stringWithFormat:@"%@/Pictures",NSHomeDirectory()]
                //どのファイルを選択しておくか
                file : @"Documents"
                //選べるファイルの拡張子（nillにするとなんでもOK、今回はNSImageでサポートされてる画像）
                types : [NSImage imageFileTypes]];
    
    if ( opRet == NSOKButton ) { // OPENPanelのボタンがOKなら
        //選択されたファイルのパスを取得
        NSString *filepath = [opPanel filename];
        //NSString *message = [NSString stringWithFormat:@"select - %@\n",filepath];
        //NSLog(message);
        [self viewFileDatas:filepath];
    }
}

/*情報を表示
*テーブル内の選択項目の情報を表示する。
*/
- (IBAction)info:(NSButton *)sender {
    //NSLog(@"info...");
    
    MDItemRef  item;
    NSString  *filepath;
    int row_num;
    row_num = [FileTable selectedRow];
    //NSString *message = [NSString stringWithFormat:@"select - %d",row_num];
    //NSLog(message);
    if(row_num > -1){
        item = (MDItemRef)MDQueryGetResultAtIndex(query, row_num);
        filepath = (NSString*)MDItemCopyAttribute(item, kMDItemPath);
        //NSLog(filepath);
        [self viewFileDatas:filepath];
    }
}

/**Spotlightコメントを変更する関数
*[memo]
*日本語があやしい
*実際に適用されるまでにタイムラグがある（ファイル内のmetadata以外にどこかにデータベースみたいのがあるらしいが、更新方法が不明……）
*/
- (IBAction)changeComment:(NSButton *)sender {
    //NSLog(@"changeComment...");
    
    int len;
    NSString *getComment = [SpotComment stringValue];
    NSString  *path;
    
    path = (NSString*)MDItemCopyAttribute(inspectedRef, kMDItemPath);
    //NSLog(path);
    
    NSLog(getComment);
    NSLog(path);
    
    if((getComment != nil) && (path != nil)){
        NSString *EAname = @"com.apple.metadata:kMDItemFinderComment";
     
        len = strlen([getComment UTF8String]);
    
        printf("%s [%s] - %d \n",[EAname UTF8String],[getComment UTF8String],len);
    
        //日本語の動作があやしい（関数そのものの問題？）
        if (0 != setxattr([path UTF8String],[EAname UTF8String],[getComment UTF8String],len,0, 0)) {
                NSLog(@"Error in setattr");
        }
    
        [self viewFileDatas:path];//もう一度読み込む、だがしかしすぐには適用されないらしい。
    }
}

/**検索結果の保存（.savedSearch）
*テンプレート(templete.savedSearch)をもとに検索フォルダを作成する
*[memo]
*テンプレートを用意して変更が必要な部分を書き換えている
*保存場所は保存ウィンドウで選べる
*/
- (IBAction)saveSearch:(NSButton *)sender {
    //NSLog(@"saveSearch...");
    
    NSString *xmlsrting;//テンプレートから取得したXMLデータ
    NSError **err;
    NSSavePanel *sp;
    int runResult;
    NSFileManager *myFileManager = [NSFileManager defaultManager];
    BOOL writhing;
    
    //savedSearchのテンプレートを読み込む
    NSString *templetePath = [NSString stringWithFormat:@"%@/Contents/Resources/template.savedSearch"
                                                            ,[[NSBundle mainBundle] bundlePath]];
    //NSLog(templetePath);
    xmlsrting = [NSString stringWithContentsOfFile:templetePath];
    
    //NSLog(xmlsrting);

    
    //テンプレートの$KEYWORDをユーザが入力したキーワードに変更
    xmlsrting = [xmlsrting stringByReplacingOccurrencesOfString:@"$KEYWORD" withString:[searchField stringValue]];

    //NSLog(xmlsrting);
    
    //テンプレートの$USERNAMEをユーザ名に変更
    xmlsrting = [xmlsrting stringByReplacingOccurrencesOfString:@"$USERNAME" withString:NSUserName()];

    //NSLog(xmlsrting);
    
    //NSSavePanelのインスタンスを取得
    sp = [NSSavePanel savePanel];
 
    //属性を設定
    //[sp setAccessoryView:newView];
    [sp setRequiredFileType:@"savedSearch"];
 
    //NSSavePanelを表示
    runResult = [sp runModalForDirectory:NSHomeDirectory() file:@""];
 
    //成功したら指定したファイル名で保存
    if (runResult == NSOKButton) {
        //NSLog([sp filename]);
        writhing = [xmlsrting writeToFile:[sp filename] 
                atomically:YES 
                encoding:NSUTF8StringEncoding
                error:err];
    
        if(writhing == NO || ![myFileManager fileExistsAtPath:[sp filename]]){
            NSLog(@"Error : can't create smart folder");
            NSBeep();
        }
    }
    
    
    
}


/*Spotlightでファイル検索
*検索フィールドで入力されたキーワードをもとに、「~/Picture」内の画像ファイルを検索して表に表示
*/
- (IBAction)Search:(NSSearchField *)sender {
    
    //NSLog(@"Make query...");
    
    /* queryを作成 */
    NSString *queryString;
    NSString *userEnteredString;

    //ユーザが入力した文字列を取得
    userEnteredString = [searchField stringValue];

    if (query){
        //NSLog(@"release query");
        /* notificationsを停止 */
        [[NSNotificationCenter defaultCenter] removeObserver:self];

        /* 古いqueryを解放 */
        CFRelease(query);
        query = NULL;
    }

    //検索文字列を生成
    //「kMDItemContentTypeTree=*public.image*」画像しか表示しない
    queryString = [NSString stringWithFormat:
    //                @"*='%@'wcd || kMDItemTextContent = '%@'cd",userEnteredString,userEnteredString];
    //                @"*='%@'wcd && !(kMDItemMediaTypes=*) && !(kMDItemKind='フォルダ')"
                    @"(*='*%@*'wcd || kMDItemTextContent = '*%@*'cd) && (kMDItemContentTypeTree=*public.image*)"
                    ,userEnteredString,userEnteredString];
    
    //NSLog(queryString);
    
    //クエリを作成、取得する値はkMDItemDisplayName（つまりファイル名）
    query = MDQueryCreate(kCFAllocatorDefault,(CFStringRef)queryString,NULL,
                            (CFArrayRef)[NSArray arrayWithObjects:(id)kMDItemDisplayName,nil]);
    
    if (query){
        /* notificationsを設定 */
        
        //終了
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(updateData:)
                                              name:(NSString*)kMDQueryDidFinishNotification object:(id)query];

        //生成中
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(updateData:)
                                              name:(NSString*)kMDQueryProgressNotification object:(id)query];

        //更新終了
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(updateData:)
                                              name:(NSString*)kMDQueryDidUpdateNotification object:(id)query];
    }
    //クエリにサーチスコープとやらを設定
    MDQuerySetSearchScope(query, (CFArrayRef)[NSArray arrayWithObjects:(id)kMDQueryScopeHome,nil],0);
    //クエリを実行
    MDQueryExecute(query, kMDQueryWantsUpdates);
    
}

/*情報を表示
*@param[in] (NSString)filepath ファイルのパス
*ファイルパスからデータを取得し、TextViewに出力する。
*/
- (void)viewFileDatas:(NSString *)filepath {

    //NSLog(@"View File's Data...");

    [FileData setEditable:YES];
    
    //現在表示されている情報を削除
    NSRange	wholeRange;
    [FileData selectAll:nil];
    wholeRange = [FileData selectedRange];
    [FileData replaceCharactersInRange:wholeRange withString:@""];
    
    CFStringRef attributeName;
    NSMutableString *formattedValue;
    id attribute;
    id value;
    
    NSString *message;
    
    //NSImageViewに画像を表示
    [Imege setImage:[[[NSImage alloc] initWithContentsOfFile:filepath] autorelease]];
    
    message = [NSString stringWithFormat:@"%@ \n",filepath];
    [self appendText:message];
    
    
    //MDItemを作成
    inspectedRef = MDItemCreate(kCFAllocatorDefault,(CFStringRef)filepath);
    if (inspectedRef){
        //属性名の配列を取得
        inspectedRefAttributeNames = MDItemCopyAttributeNames(inspectedRef);
        //属性の内容の配列を取得
        inspectedRefAttributeValues = MDItemCopyAttributes(inspectedRef,inspectedRefAttributeNames);
    }

    int i;
    //配列の長さを調べる
    int arraycount = CFArrayGetCount(inspectedRefAttributeNames);
    for(i=0;i<arraycount;i++){
    
        //インデックスから配列の属性名を取得
        attributeName = CFArrayGetValueAtIndex(inspectedRefAttributeNames,i);
        //属性名を読みやすい文字に変換　ex)kMDItemKind -> Kind
        attribute = (id)MDSchemaCopyDisplayNameForAttribute(attributeName);
        if([(NSString *)attribute length]){
            message = [NSString stringWithFormat:@"[%@] -> ",attribute];
            [self appendText:message];
        }else{//「読みやすい文字」が用意されてないものもある
            message = [NSString stringWithFormat:@"[%@] -> ",attributeName];
            [self appendText:message];
        }
        
        //属性名で指定されたinspectedRefAttributeValuesの中身を取得
        value = (id)CFDictionaryGetValue(inspectedRefAttributeValues,attributeName);
        
        
        //できればstring型で返す
        if ([value respondsToSelector: @selector(descriptionInStringsFileFormat)]){
            formattedValue = [[value descriptionInStringsFileFormat] mutableCopy];
        }else{
            formattedValue = [[value description] mutableCopy];
        }
        
        /* \t,\r,\n （タブコードと改行コード）を削除 */
        [formattedValue replaceOccurrencesOfString:@"\t" withString:@"" options:0 range:NSMakeRange(0,[formattedValue length])];
        [formattedValue replaceOccurrencesOfString:@"\r" withString:@"" options:0 range:NSMakeRange(0,[formattedValue length])];
        [formattedValue replaceOccurrencesOfString:@"\n" withString:@"" options:0 range:NSMakeRange(0,[formattedValue length])];
        
        if([attribute isEqualToString:@"Display name"] | [attribute isEqualToString:@"Filename"]){
            //ファイル名はクリックするとそのファイルを開くようにする
            NSURL *fileurl = [NSURL fileURLWithPath:filepath];
            //ファイルURLのリンクを作成
            NSDictionary *attrs = [NSDictionary dictionaryWithObject:fileurl forKey:NSLinkAttributeName];
            //Link属性付きの文字列に変換
            NSAttributedString* linkname = [[NSAttributedString alloc] initWithString:formattedValue attributes:attrs];
            //[self appendText:linkname];//「warning: pussing argument 1 of 'appendText' from distinct Objective-C」がでる
            [FileData insertText:linkname];[self appendText:@"\n"];
            [SpotComment setEditable:YES];
        }else if([attribute isEqualToString:@"Spotlight comment"]){
            //NSLog(formattedValue);
            [SpotComment setStringValue:formattedValue];
            message = [NSString stringWithFormat:@"%@ \n",formattedValue];
            [self appendText:message];
        }else{
            message = [NSString stringWithFormat:@"%@ \n",formattedValue];
            [self appendText:message];
        }
    }
    [FileData setEditable:NO];
}

/*文字列をTextViewに追加
*@param[in] (NSString)message 文字列
*文字列をTextViewの末尾に追加
*
*[memo]
*ただ「insertText」だけをするとカーソルの位置（デフォルトでは先頭）に挿入されてしまう。
*「setEditable」がNOだと入力できない。
*/
- (void)appendText:(NSString *)message
{
    NSRange	wholeRange;
    NSRange	endRange;
        
	[FileData selectAll:nil];
    //TextViewの中身をすべて選択
    wholeRange = [FileData selectedRange];
    //選択部分の大きさを調べる
    endRange = NSMakeRange(wholeRange.length, 0);
    //選択位置を末尾にする
    [FileData setSelectedRange:endRange];
    [FileData insertText:message];
}


/** Table View 関連 **/
/* クエリが完成したら */
- (void)queryDone:(NSNotification *)notification{
    //NSLog(@"query Done...");
    [self updateData:notification];
}

/* テーブルのデータを更新 */
- (void)updateData:(NSNotification *)notification{
    //NSLog(@"update Data...");
    [FileTable reloadData];
    
    //ウィンドウのタイトルを変更
    [[FileTable window] setTitle:[NSString stringWithFormat: @"%@ - %d matches", 
                                            [searchField stringValue], MDQueryGetResultCount(query)]];
}

/* テーブルの行数を計算 */
- (int)numberOfRowsInTableView:(NSTableView *)sender{
    //NSLog(@"count rows...");
    return query ? MDQueryGetResultCount(query) : 0;
}

/* テーブルにデータを表示 */
- (id)tableView:(NSTableView *)FileTable objectValueForTableColumn:(NSTableColumn *)tableColumn row:(int)row{

    //NSLog(@"Create Table...");
    
    NSString  *ident;
    NSObject  *object;
    MDItemRef  item;
    NSString  *path;

    ident = [tableColumn identifier];
    item = (MDItemRef)MDQueryGetResultAtIndex(query, row);

    //アイコン（サムネイルではない）
    if ([ident isEqualToString:@"icon"]) {
        path = (NSString*)MDItemCopyAttribute(item, kMDItemPath);
        object = [[NSWorkspace sharedWorkspace] iconForFile: path];
        [path  release];
    
    //ファイル名
    }else if ([ident isEqualToString:@"fileName"]) {
        object = (NSObject*)MDItemCopyAttribute(item, kMDItemDisplayName);
        [object autorelease];
    
    //Spotlightコメント
    }else if ([ident isEqualToString:@"spotlightComment"]) {
        object = (NSObject*)MDItemCopyAttribute(item,kMDItemFinderComment);
        [object autorelease];
    
    //ファイルタイプ
    }else if ([ident isEqualToString:@"fileType"]) {
        object = (NSObject*)MDItemCopyAttribute(item,kMDItemKind);
        [object autorelease];
        
    //画像のサイズ
    }else if ([ident isEqualToString:@"size"]) {

        id value;
        NSMutableString *height;
        NSMutableString *width;
        
        //画像の幅
        value = (id)MDItemCopyAttribute(item,kMDItemPixelWidth);
        
        if ([value respondsToSelector: @selector(descriptionInStringsFileFormat)]){
            width = [[value descriptionInStringsFileFormat] mutableCopy];
        }else{
            width = [[value description] mutableCopy];
        }
        
        [width replaceOccurrencesOfString:@"\t" withString:@"" options:0 range:NSMakeRange(0,[width length])];
        [width replaceOccurrencesOfString:@"\r" withString:@"" options:0 range:NSMakeRange(0,[width length])];
        [width replaceOccurrencesOfString:@"\n" withString:@"" options:0 range:NSMakeRange(0,[width length])];
        
        //画像の高さ
        value = (id)MDItemCopyAttribute(item,kMDItemPixelHeight);
        
        if ([value respondsToSelector: @selector(descriptionInStringsFileFormat)]){
            height = [[value descriptionInStringsFileFormat] mutableCopy];
        }else{
            height = [[value description] mutableCopy];
        }
        
        [height replaceOccurrencesOfString:@"\t" withString:@"" options:0 range:NSMakeRange(0,[height length])];
        [height replaceOccurrencesOfString:@"\r" withString:@"" options:0 range:NSMakeRange(0,[height length])];
        [height replaceOccurrencesOfString:@"\n" withString:@"" options:0 range:NSMakeRange(0,[height length])];
        
        object = [NSString stringWithFormat:@"%@x%@",width,height];
    }
    
    return object;
}

@end
